/*
 * 'rebel' branch modifications:
 *     Copyright (C) 2010 Tuxera. All Rights Reserved.
 */

/*
 * Copyright (C) 2006-2008 Google. All Rights Reserved.
 * Amit Singh <singh@>
 */

/*
 * 'rebel' branch modifications:
 *     Copyright (C) Tuxera 2010. All Rights Reserved.
 */

#ifndef _FUSE_VERSION_H_
#define _FUSE_VERSION_H_

#ifdef KERNEL
#include <libkern/version.h>
#elif defined(_INFOPLIST_VERSION_MAJOR)
/* Dummy version for the preprocessing stage of 'Info.plist'. */
#define VERSION_MAJOR _INFOPLIST_VERSION_MAJOR
#else
#ifndef __ENVIRONMENT_MAC_OS_X_VERSION_MIN_REQUIRED__
#error "Missing predefined macro __ENVIRONMENT_MAC_OS_X_VERSION_MIN_REQUIRED__. Cannot continue."
#elif __ENVIRONMENT_MAC_OS_X_VERSION_MIN_REQUIRED__ < 1040
#error "Unsupported Mac OS X version (< 10.4)."
#elif __ENVIRONMENT_MAC_OS_X_VERSION_MIN_REQUIRED__ == 1040
#define VERSION_MAJOR 8
#elif __ENVIRONMENT_MAC_OS_X_VERSION_MIN_REQUIRED__ == 1050
#define VERSION_MAJOR 9
#elif __ENVIRONMENT_MAC_OS_X_VERSION_MIN_REQUIRED__ == 1060
#define VERSION_MAJOR 10
#elif __ENVIRONMENT_MAC_OS_X_VERSION_MIN_REQUIRED__ == 1070
#define VERSION_MAJOR 11
#else
#error "Mac OS X version is too new or uneven (in which case you should add a -mmacosx-version-min=10.X flag when compiling)."
#endif
#endif /* defined(KERNEL) */

#define MACFUSE_STRINGIFY(s)         MACFUSE_STRINGIFY_BACKEND(s)
#define MACFUSE_STRINGIFY_BACKEND(s) #s

/* Add things here. */

#define MACFUSE_FS_TYPE_LITERAL fusefs_txantfs
#define MACFUSE_FS_TYPE         MACFUSE_STRINGIFY(MACFUSE_FS_TYPE_LITERAL)

#define MACFUSE_BUNDLE_IDENTIFIER_LITERAL \
        com.tuxera.filesystems.tufsfs.MACFUSE_FS_TYPE_LITERAL
#define MACFUSE_BUNDLE_IDENTIFIER \
        MACFUSE_STRINGIFY(MACFUSE_BUNDLE_IDENTIFIER_LITERAL)

#define MACFUSE_BUNDLE_IDENTIFIER_TRUNK_LITERAL  tufsfs
#define MACFUSE_BUNDLE_IDENTIFIER_TRUNK \
        MACFUSE_STRINGIFY(MACFUSE_BUNDLE_IDENTIFIER_TRUNK_LITERAL)

#define MACFUSE_TIMESTAMP __DATE__ ", " __TIME__

#if VERSION_MAJOR > 8
#include "fuse_version_10.5.h"
#else
#include "fuse_version_10.4.h"
#endif /* VERSION_MAJOR > 8 */
#define MACFUSE_VERSION         MACFUSE_STRINGIFY(MACFUSE_VERSION_LITERAL)

#define FUSE_KPI_GEQ(M, m) \
    (FUSE_KERNEL_VERSION > (M) || \
    (FUSE_KERNEL_VERSION == (M) && FUSE_KERNEL_MINOR_VERSION >= (m)))

#endif /* _FUSE_VERSION_H_ */
